#include <bits/stdc++.h>

#define X first
#define Y second
#define PB push_back
#define x first
#define y second
#define pb push_back
#define all(a) begin(a),end(a)

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;

const int N=55,MOD=1e9+7;
const char en='\n';
const ll LLINF=1ll<<60;

int n, a, b, d[N];
vector<pii> ans;


ll dist(ll x1, ll y1, ll x2, ll y2) {
	return abs(x1 - x2) + abs(y1 - y2);
}

pair<bool, pii> segment(ll Ax, ll Ay, ll Bx, ll By, ll x2, ll y2, ll d2) {
	if(dist(Ax, Ay, x2, y2) <= d2 && dist(Bx, By, x2, y2) > d2) {
		ll k = dist(Ax, Ay, Bx, By);
		ll cur = 0;
		ll t1 = (Ax < Bx) ? 1 : -1;
		ll t2 = (Ay < By) ? 1 : -1;
		for(int t = 42;t >= 0;t--) {
			if((1LL << t) + cur > k) continue;
			ll Cx = Ax + t1 * (cur + (1LL << t)), Cy = Ay + t2 * (cur + (1LL << t));
			if(dist(Cx, Cy, x2, y2) <= d2) cur += (1LL << t);
		}
		return {true, (pii){Ax + t1 * cur, Ay + t2 * cur}};
	}
	return {false, (pii){0, 0}};
}

pair<bool, pii> to_wrap_find_point(ll x1, ll y1, ll d1, ll x2, ll y2, ll d2) {
	if (d1 == 0) {
		if(dist(x1, y1, x2, y2) == d2) {
			return {true, (pii){x1, y1}};
		} else {
			return {false, (pii){0, 0}};
		}
	}
	if(d2 == 0) {
		if(dist(x1, y1, x2, y2) == d1) {
			return {true, (pii){x2, y2}};
		} else {
			return {false, (pii){0, 0}};
		}
	}
	
	ll Ax = x1 + d1, Ay = y1;
	ll Bx = x1, By = y1 + d1;
	ll Cx = x1 - d1, Cy = y1;
	ll Dx = x1, Dy = y1 - d1;
	
	if(dist(Ax, Ay, x2, y2) == d2) return {true, (pii){Ax, Ay}};
	if(dist(Bx, By, x2, y2) == d2) return {true, (pii){Bx, By}};
	if(dist(Cx, Cy, x2, y2) == d2) return {true, (pii){Cx, Cy}};
	if(dist(Dx, Dy, x2, y2) == d2) return {true, (pii){Dx, Dy}};
	
	pair<bool, pii> tmp = segment(Ax, Ay, Bx, By, x2, y2, d2);
	if(tmp.first) return tmp;
	tmp = segment(Ax, Ay, Dx, Dy, x2, y2, d2);
	if(tmp.first) return tmp;
	tmp = segment(Bx, By, Ax, Ay, x2, y2, d2);
	if(tmp.first) return tmp;
	tmp = segment(Bx, By, Cx, Cy, x2, y2, d2);
	if(tmp.first) return tmp;
	tmp = segment(Cx, Cy, Bx, By, x2, y2, d2);
	if(tmp.first) return tmp;
	tmp = segment(Cx, Cy, Dx, Dy, x2, y2, d2);
	if(tmp.first) return tmp;
	tmp = segment(Dx, Dy, Ax, Ay, x2, y2, d2);
	if(tmp.first) return tmp;
	tmp = segment(Dx, Dy, Cx, Cy, x2, y2, d2);
	if(tmp.first) return tmp;
	return {false, (pii){0,0}};
}

pair<bool, pii> find_point(ll x1, ll y1, ll d1, ll x2, ll y2, ll d2) {
	pair<bool, pii> tmp = to_wrap_find_point(x1, y1, d1, x2, y2, d2);
	if(tmp.first) return tmp;
	return to_wrap_find_point(x2, y2, d2, x1, y1, d1);
}



int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	
	cin >> n >> a >> b; --n;
	for (int i = 0; i < n; ++i) cin >> d[i];
	
	ll sum = (ll)accumulate(d, d + n, 0LL);
	if ((sum & 1LL) != (ll)((a + b) & 1) || sum < a + b) {
		cout << "NO\n"; return 0;
	}
	ans.push_back({0, 0});
	ll cur_x = 0, cur_y = 0;
	int i = 0;
	while (i < n && dist(cur_x - d[i], 0, a, b) <= sum - d[i]) {
		cur_x -= d[i];
		sum -= d[i];
		ans.push_back({cur_x, 0});
		++i;
	}
	
	pair<bool, pair<ll, ll>> nxt = find_point(cur_x, cur_y, d[i], a, b, sum - d[i]);
	
	
	if (!nxt.first) {
		cout << "NO\n"; return 0;
	}
	
	assert(dist(cur_x, cur_y, nxt.second.first, nxt.second.second) == d[i]);
	assert(dist(a, b, nxt.second.first, nxt.second.second) == sum - d[i]);
	
	cur_x = nxt.second.first, cur_y = nxt.second.second;
	ans.push_back({cur_x, cur_y});
	
	for (++i; i < n; ++i) {
		
		ll rem = d[i];
		if (cur_x < a || cur_x > a) {
			ll dif = min(abs(cur_x - a), rem);
			rem -= dif;
			if (cur_x < a) cur_x += dif;
			else cur_x -= dif;
		}
		if (cur_y < b || cur_y > b) {
			ll dif = min(abs(cur_y - b), rem);
			rem -= dif;
			if (cur_y < b) cur_y += dif;
			else cur_y -= dif;
		}
		ans.push_back({cur_x, cur_y});
	}
	
	for (int i = 0; i < n; ++i) {
		if (dist(ans[i].first, ans[i].second, ans[i + 1].first, ans[i + 1].second) != d[i]) {
			while (1);
		}
	}
	
	cout << "YES\n";
	for (auto x : ans) {
		cout << x.first << " " << x.second << "\n";
	}
	
	return 0;
}
